﻿package  
{
	import fl.controls.Button;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.DataEvent;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.BevelFilter;
	import flash.net.FileFilter;
	import flash.net.FileReference;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	
	/**
	 * ...
	 * @author ZhangYi
	 */
	public class FileReferenceUpload extends Sprite
	{
		private var _btn:Button;
		private var _fileRef:FileReference;
		private var _loader:Loader;
		
		public function FileReferenceUpload() 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			inited();
		}
		
		private function inited():void {
			_btn = new Button();
			_btn.label = "选择图片";
			_btn.x = 100;
			_btn.y = 100;
			addChild(_btn);
			
			_btn.addEventListener(MouseEvent.CLICK, clickHandler);
			
			_loader = new Loader();
			_loader.x = 100;
			_loader.y = 150;
			addChild(_loader);
			
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, resizeImage);
		}
		
		private function resizeImage(evt:Event):void {
			var size:uint = 300;
			
			var w:Number = _loader.width;
			var h:Number = _loader.height;
			
			var scale:Number = w / h;
			
			if (w > h) {
				_loader.width = size;
				_loader.height = size / scale;
			} else if (h > w) {
				_loader.height = size;
				_loader.width = size * scale;
			} else {
				_loader.height = _loader.width = size;
			}
			
			var req:URLRequest = new URLRequest("http://meteoric.com/test/uploadFile/upload_3.php");
			
			
			_fileRef.upload(req);
		}
		
		private function getImageFilter():FileFilter {
			return new FileFilter("支持的图片类型(*.jpg;*.jpeg;*.gif;*.png)", "*.jpg;*.jpeg;*.gif;*.png");
		}
		
		private function getFilterTypes():Array {
			return [
				getImageFilter(),
				new FileFilter("GIF 文件 (*.gif)", "*.gif"),
				new FileFilter("PNG 文件 (*.png)", "*.png"),
				new FileFilter("JPG 文件 (*.jpg)", "*.jpg;*.jpeg")
			];
		}
		
		private function clickHandler(evt:MouseEvent):void {
			_fileRef = null;
			
			_fileRef = new FileReference();
			_fileRef.addEventListener(Event.SELECT, selectHandler, false, 0, true);
			_fileRef.addEventListener(Event.COMPLETE, onloadedHandler, false, 0, true);
			_fileRef.addEventListener(DataEvent.UPLOAD_COMPLETE_DATA, uploadImageCompleteHandler, false, 0, true);
			
			_fileRef.browse(getFilterTypes());
		}
		
		private function selectHandler(evt:Event):void {
			_fileRef.removeEventListener(Event.SELECT, selectHandler);
			
			_fileRef.load();
		}
		
		private function onloadedHandler(evt:Event):void {
			_fileRef.removeEventListener(Event.COMPLETE, onloadedHandler);
			
			_loader.loadBytes(_fileRef.data);
		}
		
		private function uploadImageCompleteHandler(evt:DataEvent):void {
			trace(evt.data);
			
			_fileRef.removeEventListener(DataEvent.UPLOAD_COMPLETE_DATA, uploadImageCompleteHandler);
			
			_fileRef = null;
		}
	}

}